diff --git a/game/client/src/main/java/net/minecraft/client/render/FogManager.java b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
index f179204db..f18de7261 100644
--- a/game/client/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
@@ -17,7 +17,6 @@ import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
 import net.minecraft.client.render.camera.CameraUtil;
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.world.Dimension;
 import org.lwjgl.opengl.GL41;
 
 public class FogManager {
@@ -32,6 +31,7 @@ public class FogManager {
 
     public float fogBrightnessOld;
     public float fogBrightness;
+    private float oldWorldFogTransition = 0.0f;
 
     public FogManager(@NotNull Minecraft mc) {
         this.mc = mc;
@@ -60,6 +60,8 @@ public class FogManager {
             cameraState = 1;
         } else if (CameraUtil.isUnderLiquid(this.mc.activeCamera, this.mc.currentWorld, Materials.LAVA, partialTick)) {
             cameraState = 2;
+        } else if (CameraUtil.isUnderLiquid(this.mc.activeCamera, this.mc.currentWorld, Materials.ACID, partialTick)) {
+            cameraState = 3;
         } else {
             cameraState = 0;
         }
@@ -79,6 +81,13 @@ public class FogManager {
                 dest.fogDensity = 2.0f;
                 break;
             }
+            case 3: {
+                dest.fogMode = FogState.Mode.EXP;
+                dest.fogDensity = 1.2F;
+                dest.fogStart = 0.0f;
+                dest.fogEnd = 0.1f;
+                break;
+            }
             default: {
                 float fogDistance = farPlaneDistance;
                 float maxFogDistance = GameSettings.RENDER_DISTANCE.highest * 16;
@@ -105,6 +114,23 @@ public class FogManager {
                 }
             }
         }
+
+        TilePos cameraTile = this.mc.activeCamera.getTilePos();
+        float fogTransitionSpeed = 0.0005f;
+
+        if (this.mc.currentWorld.getBlockBiome(cameraTile) == net.minecraft.core.world.biome.Biomes.NETHER_OLD_WORLD) {
+            oldWorldFogTransition += fogTransitionSpeed;
+        } else {
+            oldWorldFogTransition -= fogTransitionSpeed;
+        }
+
+        oldWorldFogTransition = MathHelper.clamp(oldWorldFogTransition, 0.0f, 1.0f);
+
+        if (oldWorldFogTransition > 0.0f) {
+            dest.fogStart = dest.fogStart + (farPlaneDistance * 0.15F - dest.fogStart) * oldWorldFogTransition;
+            dest.fogEnd = dest.fogEnd + (farPlaneDistance * 0.45F - dest.fogEnd) * oldWorldFogTransition;
+        }
+
         return dest;
     }
 
@@ -167,6 +193,10 @@ public class FogManager {
             this.fogRed = 0.6F;
             this.fogGreen = 0.1F;
             this.fogBlue = 0.0F;
+        } else if (CameraUtil.isUnderLiquid(this.mc.activeCamera, world, Materials.ACID, partialTick)) {
+            this.fogRed = 0.2F;
+            this.fogGreen = 0.2F;
+            this.fogBlue = 0.1F;
         }
 
         float brightness = this.fogBrightnessOld + (this.fogBrightness - this.fogBrightnessOld) * partialTick;
diff --git a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
index c6d75ba27..98ec47006 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -20,6 +20,7 @@ import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.pos.TilePos;
 import org.joml.Math;
@@ -142,7 +143,6 @@ public class ItemRenderer {
         GLRenderer.disableState(State.DEPTH_TEST);
 
         if (this.mc.thePlayer.isOnFire()) {
-            TextureRegistry.worldAtlas.bind();
             renderFireInFirstPerson(partialTicks);
         }
 
@@ -242,35 +242,49 @@ public class ItemRenderer {
         GLRenderer.popFrame();
     }
 
-    private void renderFireInFirstPerson(float f) {
-        TessellatorGeneral tessellator = GLRenderer.getTessellator();
+    private void renderFireInFirstPerson(float partialTick) {
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
+
+        final String texturePath = ClientFireOverlayHelper.getFireOverlayTexture(this.mc.thePlayer);
+        final IconCoordinate texture = TextureRegistry.getTexture(texturePath);
+
+        texture.parentAtlas.bind();
+
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 0.85F);
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
-        float scale = 1.5f;
+
+        final boolean lightingWasOn = GLRenderer.globalGetLightEnabled();
+        GLRenderer.globalSetLightEnabled(false);
+        final byte restoreLightmap = this.mc.thePlayer.getLightIndex(partialTick);
+        GLRenderer.setLightmapCoord1i(LightIndexHelper.lightIndex2i(15, 15));
+
+        final float scale = 1.5f;
         for (int i = 0; i < 2; i++) {
             GLRenderer.pushFrame();
-            IconCoordinate texture = TextureRegistry.getTexture("minecraft:block/fire");
-            float uMin = (float) texture.getIconUMin();
-            float uMax = (float) texture.getIconUMax();
-            float vMin = (float) texture.getIconVMin();
-            float vMax = (float) texture.getIconVMax();
-            float xMin = (0.0F - scale) / 2.0F;
-            float xMax = xMin + scale;
-            float yMin = 0.0F - scale / 2.0F;
-            float yMax = yMin + scale;
-            float f10 = -0.5F;
+            final float uMin = (float) texture.getIconUMin();
+            final float uMax = (float) texture.getIconUMax();
+            final float vMin = (float) texture.getIconVMin();
+            final float vMax = (float) texture.getIconVMax();
+            final float xMin = (0.0F - scale) / 2.0F;
+            final float xMax = xMin + scale;
+            final float yMin = 0.0F - scale / 2.0F;
+            final float yMax = yMin + scale;
+            final float zPlane = -0.5F;
             GLRenderer.modelM4f().translate((float) (-(i * 2 - 1)) * 0.4F, -0.3F, 0.0F);
             GLRenderer.modelM4f().rotateY(Math.toRadians((float) (i * 2 - 1) * 10F));
             tessellator.startDrawingQuads();
-            tessellator.addVertexWithUV(xMin, yMin - 0.5, f10, uMax, vMax);
-            tessellator.addVertexWithUV(xMax, yMin - 0.5, f10, uMin, vMax);
-            tessellator.addVertexWithUV(xMax, yMax, f10, uMin, vMin);
-            tessellator.addVertexWithUV(xMin, yMax, f10, uMax, vMin);
+            tessellator.addVertexWithUV(xMin, yMin - 0.5, zPlane, uMax, vMax);
+            tessellator.addVertexWithUV(xMax, yMin - 0.5, zPlane, uMin, vMax);
+            tessellator.addVertexWithUV(xMax, yMax, zPlane, uMin, vMin);
+            tessellator.addVertexWithUV(xMin, yMax, zPlane, uMax, vMin);
             tessellator.draw();
             GLRenderer.popFrame();
         }
 
+        GLRenderer.setLightmapCoord1i(restoreLightmap);
+        GLRenderer.globalSetLightEnabled(lightingWasOn);
+
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         GLRenderer.disableState(State.BLEND);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
index 3158261e4..79a2c9bfa 100644
--- a/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
+++ b/game/client/src/main/java/net/minecraft/client/render/ParticleEngine.java
@@ -1,11 +1,13 @@
 package net.minecraft.client.render;
 
 import it.unimi.dsi.fastutil.objects.ObjectArrayList;
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.enums.ParticlesQuality;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.particle.Particle;
 import net.minecraft.client.render.particle.ParticleBlockBreaking;
+import net.minecraft.client.render.particle.ParticleFlame;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.CompareFunc;
 import net.minecraft.client.render.renderer.GLRenderer;
@@ -16,15 +18,20 @@ import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.tessellator.TessellatorParticleShader;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicFire;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL41;
 
+import java.util.HashMap;
 import java.util.List;
+import java.util.Map;
 import java.util.Random;
 
 /**
@@ -40,6 +47,11 @@ public final class ParticleEngine {
     private final List<Particle>[] particles;
     private final Random rand;
 
+    private final Map<Class<?>, ObjectArrayList<Particle>> particlePools = new HashMap<>();
+    private final AABBd cullingAABB = new AABBd();
+    private int globalTick = 0;
+    private double lastCamX, lastCamY, lastCamZ;
+
     public ParticleEngine(World world) {
         this.particles = new ObjectArrayList[TEXTURE_COUNT];
         this.rand = new Random();
@@ -54,27 +66,76 @@ public final class ParticleEngine {
     /**
      * Adds a new particle to the engine.
      *
-     * @param p The particle to add.
+     * @param particle The particle to add.
      */
-    public void add(Particle p) {
-        int t = p.getParticleTexture();
+    public void add(@NotNull Particle particle) {
+        int t = particle.getParticleTexture();
+
         if (this.particles[t].size() >= GameSettings.PARTICLES_CAP.value) {
-            this.particles[t].remove(0);
+            // Find the furthest particle to delete instead of just the oldest
+            int indexToRemove = getIndexToRemove(t);
+
+            // Return the furthest particle to the Object Pool
+            Particle removed = this.particles[t].remove(indexToRemove);
+            ObjectArrayList<Particle> pool = this.particlePools.computeIfAbsent(removed.getClass(), k -> new ObjectArrayList<>());
+            if (pool.size() < GameSettings.PARTICLES_CAP.value) {
+                pool.add(removed);
+            }
+        }
+
+        this.particles[t].add(particle);
+        particle.init();
+    }
+
+    private int getIndexToRemove(int t) {
+        int indexToRemove = 0;
+        double maxDistSq = -1;
+
+        // Only scan a handful of particles to avoid CPU lag when overflowing
+        int scanLimit = Math.min(50, this.particles[t].size());
+
+        for (int i = 0; i < scanLimit; i++) {
+            Particle check = this.particles[t].get(i);
+            double distSq = (check.x - lastCamX)*(check.x - lastCamX) +
+                    (check.y - lastCamY)*(check.y - lastCamY) +
+                    (check.z - lastCamZ)*(check.z - lastCamZ);
+
+            if (distSq > maxDistSq) {
+                maxDistSq = distSq;
+                indexToRemove = i;
+            }
         }
-        this.particles[t].add(p);
-        p.init();
+        return indexToRemove;
     }
 
     /**
      * Ticks all the particles in the engine.
      */
     public void tick() {
+        this.globalTick++;
+
+        Player localPlayer = this.world.players.isEmpty() ? null : this.world.players.get(0);
+        if (localPlayer != null) {
+            this.world.particleEmitters.tick(this.world, localPlayer, GameSettings.PARTICLE_RENDER_DISTANCE.value);
+        }
+
         for (int tt = 0; tt < this.particles.length; tt++) {
             for (int i = 0; i < this.particles[tt].size(); i++) {
                 Particle p = this.particles[tt].get(i);
+
                 p.tick();
                 if (p.removed) {
                     this.particles[tt].remove(i--);
+
+                    Class<?> c = p.getClass();
+                    ObjectArrayList<Particle> pl = this.particlePools.get(c);
+                    if (pl == null) {
+                        pl = new ObjectArrayList<>();
+                        this.particlePools.put(c, pl);
+                    }
+                    if (pl.size() < GameSettings.PARTICLES_CAP.value) {
+                        pl.add(p);
+                    }
                 }
             }
         }
@@ -107,14 +168,40 @@ public final class ParticleEngine {
         double yOff = camera.getY(partialTick);
         double zOff = camera.getZ(partialTick);
 
-        for (int tt = 0; tt <= WORLD_TEXTURE; tt++) {
-            if (this.particles[tt].isEmpty()) {
-                continue;
-            }
+        this.lastCamX = xOff;
+        this.lastCamY = yOff;
+        this.lastCamZ = zOff;
+
+        double maxDist = GameSettings.PARTICLE_RENDER_DISTANCE.value * 16.0;
+        double maxRenderDistSq = maxDist * maxDist;
+        boolean frustumCull = GameSettings.FRUSTUM_CULLING.value;
+
+        for (int tt = 0; tt == WORLD_TEXTURE; tt++) {
+            if (this.particles[tt].isEmpty()) continue;
+
             tessellator.setTranslation(-xOff, -yOff, -zOff);
             tessellator.startDrawingParticles();
+
             for (int i = 0; i < this.particles[tt].size(); i++) {
                 Particle p = this.particles[tt].get(i);
+
+                double distSq = (p.x - xOff)*(p.x - xOff) + (p.y - yOff)*(p.y - yOff) + (p.z - zOff)*(p.z - zOff);
+                if (distSq > maxRenderDistSq) continue;
+
+                if (frustumCull) {
+                    double lerpX = net.minecraft.core.util.helper.MathHelper.lerp(p.xo, p.x, partialTick);
+                    double lerpY = net.minecraft.core.util.helper.MathHelper.lerp(p.yo, p.y, partialTick);
+                    double lerpZ = net.minecraft.core.util.helper.MathHelper.lerp(p.zo, p.z, partialTick);
+                    double r = p.size * 0.1;
+
+                    this.cullingAABB.setMin(lerpX - r, lerpY - r, lerpZ - r);
+                    this.cullingAABB.setMax(lerpX + r, lerpY + r, lerpZ + r);
+
+                    if (!camera.getFrustum().isVisible(this.cullingAABB, partialTick)) {
+                        continue;
+                    }
+                }
+
                 p.render(tessellator, partialTick);
             }
             tessellator.drawParticles();
@@ -123,6 +210,15 @@ public final class ParticleEngine {
         GLRenderer.popFrame();
     }
 
+    @SuppressWarnings("unchecked")
+    private <T extends Particle> T getPooledParticle(Class<T> type) {
+        ObjectArrayList<Particle> pool = this.particlePools.computeIfAbsent(type, k -> new ObjectArrayList<>());
+        if (!pool.isEmpty()) {
+            return (T) pool.remove(pool.size() - 1);
+        }
+        return null;
+    }
+
     /**
      * Renders all the particles in the engine whose texture type is ENTITY_PARTICLE_TEXTURE.
      * These particles are drawn using OpenGL normal-based lighting, unlike the other particles,
@@ -139,17 +235,14 @@ public final class ParticleEngine {
         double xOff = camera.getX(partialTick);
         double yOff = camera.getY(partialTick);
         double zOff = camera.getZ(partialTick);
-        TessellatorGeneral tessellator = GLRenderer.getTessellator();
         for (int i = 0; i < this.particles[tt].size(); i++) {
             Particle p = this.particles[tt].get(i);
             p.renderLit(partialTick, xOff, yOff, zOff);
         }
-
     }
 
     /**
      * Sets the world used to contain any managed particles.
-     *
      * @param world The world to use.
      */
     public void setWorld(World world) {
@@ -169,19 +262,41 @@ public final class ParticleEngine {
     public void destroy(@NotNull TilePosc blockPos, int id, int data) {
         if (GameSettings.PARTICLES_QUALITY.value == ParticlesQuality.NONE) return;
         Block<?> block = Blocks.blocksList[id];
-        if (block == null) return;
+        if (block == null || block.getLogic() instanceof BlockLogicFire) return;
         int amount = GameSettings.PARTICLES_QUALITY.value == ParticlesQuality.REDUCED ? 2 : 4;
-        if (block == Blocks.FIRE) {
-            return;
-        }
+
+        AABBdc bounds = block.getLogic().getBoundsFromState(this.world, blockPos);
+
+        double centerX = (bounds.minX() + bounds.maxX()) / 2.0D;
+        double centerY = (bounds.minY() + bounds.maxY()) / 2.0D;
+        double centerZ = (bounds.minZ() + bounds.maxZ()) / 2.0D;
+
         for (int xx = 0; xx < amount; xx++) {
             for (int yy = 0; yy < amount; yy++) {
                 for (int zz = 0; zz < amount; zz++) {
-                    double xp = blockPos.x() + (xx + 0.5D) / amount;
-                    double yp = blockPos.y() + (yy + 0.5D) / amount;
-                    double zp = blockPos.z() + (zz + 0.5D) / amount;
+
+                    double percentX = (xx + 0.5D) / amount;
+                    double percentY = (yy + 0.5D) / amount;
+                    double percentZ = (zz + 0.5D) / amount;
+
+                    double xp = blockPos.x() + bounds.minX() + (bounds.maxX() - bounds.minX()) * percentX;
+                    double yp = blockPos.y() + bounds.minY() + (bounds.maxY() - bounds.minY()) * percentY;
+                    double zp = blockPos.z() + bounds.minZ() + (bounds.maxZ() - bounds.minZ()) * percentZ;
+
                     Side side = Side.fromId(this.rand.nextInt(6));
-                    add((new ParticleBlockBreaking(this.world, xp, yp, zp, xp - blockPos.x() - 0.5D, yp - blockPos.y() - 0.5D, zp - blockPos.z() - 0.5D, block, side, data)).init(blockPos));
+
+                    double velX = xp - blockPos.x() - centerX;
+                    double velY = yp - blockPos.y() - centerY;
+                    double velZ = zp - blockPos.z() - centerZ;
+
+                    ParticleBlockBreaking particle = getPooledParticle(ParticleBlockBreaking.class);
+                    if (particle == null) {
+                        particle = new ParticleBlockBreaking(this.world, xp, yp, zp, velX, velY, velZ, block, side, data);
+                    } else {
+                        particle.reset(this.world, xp, yp, zp, velX, velY, velZ, block, side, data);
+                    }
+
+                    add(particle.init(blockPos));
                 }
             }
         }
@@ -199,7 +314,9 @@ public final class ParticleEngine {
         if (block == Blocks.AIR) {
             return;
         }
-        AABBdc bounds = block.getBounds();
+
+        AABBdc bounds = block.getLogic().getBoundsFromState(this.world, blockPos);
+
         float r = 0.1F;
         double xp = blockPos.x() + this.rand.nextDouble() * (bounds.maxX() - bounds.minX() - (r * 2.0F)) + r + bounds.minX();
         double yp = blockPos.y() + this.rand.nextDouble() * (bounds.maxY() - bounds.minY() - (r * 2.0F)) + r + bounds.minY();
@@ -217,10 +334,26 @@ public final class ParticleEngine {
         } else if (side == Side.EAST) {
             xp = blockPos.x() + bounds.maxX() + r;
         }
-        add((new ParticleBlockBreaking(this.world, xp, yp, zp, 0.0D, 0.0D, 0.0D, block, side, this.world.getBlockData(blockPos))).init(blockPos).setPower(0.2F).setScale(0.6F));
+
+        ParticleBlockBreaking p = getPooledParticle(ParticleBlockBreaking.class);
+        if (p == null) {
+            p = new ParticleBlockBreaking(this.world, xp, yp, zp, 0.0D, 0.0D, 0.0D, block, side, this.world.getBlockData(blockPos));
+        } else {
+            p.reset(this.world, xp, yp, zp, 0.0D, 0.0D, 0.0D, block, side, this.world.getBlockData(blockPos));
+        }
+
+        add(p.init(blockPos).setPower(0.2F).setScale(0.6F));
     }
 
     public int countParticles() {
         return this.particles[WORLD_TEXTURE].size() + this.particles[ENTITY_PARTICLE_TEXTURE].size();
     }
+
+    public int getGlobalTick() {
+        return globalTick;
+    }
+
+    public void setGlobalTick(int globalTick) {
+        this.globalTick = globalTick;
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 42dd596ca..0dae10083 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -1995,6 +1995,19 @@ public class RenderGlobal
                 }
 
                 break;
+
+            case EVENT_ACID_SPREAD:
+                this.world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "tile.acidbubble", 0.75F, 1.0F);
+                this.world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "random.fizz", 0.5F, 2.6F + (random.nextFloat() - random.nextFloat()) * 0.8F);
+
+                for (int i = 0; i < 10; i++) {
+                    double fx = (double) x + random.nextFloat();
+                    double fy = (double) y + random.nextFloat() * 0.5D;
+                    double fz = (double) z + random.nextFloat();
+
+                    addParticle("acidBoiling", fx, fy + 0.15, fz, 0.0D, 0.0D, 0.0D, 0, false);
+                }
+                break;
             default:
                 break;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
index 46f862f48..9bb97417d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
@@ -25,18 +25,7 @@ import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.enums.TextureAnimation;
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.render.customatlas.CustomAtlasHandler;
-import net.minecraft.client.render.dynamictexture.DynamicTexture;
-import net.minecraft.client.render.dynamictexture.DynamicTextureCalendar;
-import net.minecraft.client.render.dynamictexture.DynamicTextureClock;
-import net.minecraft.client.render.dynamictexture.DynamicTextureCompass;
-import net.minecraft.client.render.dynamictexture.DynamicTextureCustom;
-import net.minecraft.client.render.dynamictexture.DynamicTextureFire;
-import net.minecraft.client.render.dynamictexture.DynamicTextureFireflyJar;
-import net.minecraft.client.render.dynamictexture.DynamicTextureLavaFlowing;
-import net.minecraft.client.render.dynamictexture.DynamicTextureLavaStill;
-import net.minecraft.client.render.dynamictexture.DynamicTextureTrommel;
-import net.minecraft.client.render.dynamictexture.DynamicTextureWaterFlow;
-import net.minecraft.client.render.dynamictexture.DynamicTextureWaterStill;
+import net.minecraft.client.render.dynamictexture.*;
 import net.minecraft.client.render.font.Fonts;
 import net.minecraft.client.render.texture.meta.AnimationProperties;
 import net.minecraft.client.render.texture.stitcher.AtlasStitcher;
@@ -108,12 +97,13 @@ public class TextureManager {
 	}
 
 	protected void addNativeDynamicTextures(@NotNull TextureAnimation state) {
-		if (state != TextureAnimation.OFF) {addDynamicTexture(new DynamicTextureWaterStill(TextureRegistry.getTexture("minecraft:block/water_still"), TextureRegistry.getTexture("minecraft:block/water_overlay_boiling")));
-			addDynamicTexture(new DynamicTextureWaterFlow(TextureRegistry.getTexture("minecraft:block/water_flowing")));
-			addDynamicTexture(new DynamicTextureLavaStill(TextureRegistry.getTexture("minecraft:block/lava_still")));
-			addDynamicTexture(new DynamicTextureLavaFlowing(TextureRegistry.getTexture("minecraft:block/lava_flowing")));
-            addDynamicTexture(new DynamicTextureFire(TextureRegistry.getTexture("minecraft:block/fire"), false));
-            addDynamicTexture(new DynamicTextureFire(TextureRegistry.getTexture("minecraft:block/fire_cold"), true));
+		if (state != TextureAnimation.OFF) {addDynamicTexture(new DynamicTextureWaterStill(TextureRegistry.getTexture("minecraft:block/fluid/water/still"), TextureRegistry.getTexture("minecraft:block/fluid/water/overlay_boiling")));
+			addDynamicTexture(new DynamicTextureWaterFlow(TextureRegistry.getTexture("minecraft:block/fluid/water/flowing")));
+			addDynamicTexture(new DynamicTextureLavaStill(TextureRegistry.getTexture("minecraft:block/fluid/lava/still")));
+			addDynamicTexture(new DynamicTextureLavaFlowing(TextureRegistry.getTexture("minecraft:block/fluid/lava/flowing")));
+            addDynamicTexture(new DynamicTextureFire(TextureRegistry.getTexture("minecraft:block/fire"), false, false));
+            addDynamicTexture(new DynamicTextureFire(TextureRegistry.getTexture("minecraft:block/fire_cold"), true, false));
+			addDynamicTexture(new DynamicTextureFire(TextureRegistry.getTexture("minecraft:block/fire_sulfuric"), false, true));
 
 			final String[] fireflyColors = {"blue", "orange", "green", "red"};
 			for (final String color : fireflyColors) {
